diff --git a/gcc/testsuite/gcc.dg/analyzer/malloc-ipa-11.c b/gcc/testsuite/gcc.dg/analyzer/malloc-ipa-11.c
index e8a6bcc..d02250f 100644
--- a/gcc/testsuite/gcc.dg/analyzer/malloc-ipa-11.c
+++ b/gcc/testsuite/gcc.dg/analyzer/malloc-ipa-11.c
@@ -1,4 +1,4 @@
-/* { dg-additional-options "-fdiagnostics-show-line-numbers -fdiagnostics-nn-line-numbers -fdiagnostics-path-format=inline-events" } */
+/* { dg-additional-options "-fdiagnostics-show-line-numbers -fdiagnostics-nn-line-numbers -fdiagnostics-path-format=inline-events -fdiagnostics-show-caret" } */
 
 #include <stdlib.h>
 
@@ -28,66 +28,68 @@ void test (void *ptr)
 }
 
 /* { dg-begin-multiline-output "" }
+   NN |   free (victim);
+      |   ^~~~~~~~~~~~~
   'test': events 1-2
-     |
-     |   NN | void test (void *ptr)
-     |      |      ^~~~
-     |      |      |
-     |      |      (1) entry to 'test'
-     |......
-     |   NN |   may_call_free (ptr);
-     |      |   ~~~~~~~~~~~~~~~~~~~
-     |      |   |
-     |      |   (2) calling 'may_call_free' from 'test'
-     |
-     +--> 'may_call_free': events 3-6
-                 |
-                 |   NN | may_call_free (void *victim)
-                 |      | ^~~~~~~~~~~~~
-                 |      | |
-                 |      | (3) entry to 'may_call_free'
-                 |   NN | {
-                 |   NN |   if (some_condition ())
-                 |      |      ~
-                 |      |      |
-                 |      |      (4) following 'false' branch...
-                 |......
-                 |   NN |   free (victim);
-                 |      |   ~~~~~~~~~~~~~
-                 |      |   |
-                 |      |   (5) ...to here
-                 |      |   (6) first 'free' here
-                 |
-     <-----------+
-     |
+    |
+    |   NN | void test (void *ptr)
+    |      |      ^~~~
+    |      |      |
+    |      |      (1) entry to 'test'
+    |......
+    |   NN |   may_call_free (ptr);
+    |      |   ~~~~~~~~~~~~~~~~~~~
+    |      |   |
+    |      |   (2) calling 'may_call_free' from 'test'
+    |
+    +--> 'may_call_free': events 3-6
+           |
+           |   NN | may_call_free (void *victim)
+           |      | ^~~~~~~~~~~~~
+           |      | |
+           |      | (3) entry to 'may_call_free'
+           |   NN | {
+           |   NN |   if (some_condition ())
+           |      |      ~
+           |      |      |
+           |      |      (4) following 'false' branch...
+           |......
+           |   NN |   free (victim);
+           |      |   ~~~~~~~~~~~~~
+           |      |   |
+           |      |   (5) ...to here
+           |      |   (6) first 'free' here
+           |
+    <------+
+    |
   'test': events 7-8
-     |
-     |   NN |   may_call_free (ptr);
-     |      |   ^~~~~~~~~~~~~~~~~~~
-     |      |   |
-     |      |   (7) returning to 'test' from 'may_call_free'
-     |......
-     |   NN |   may_call_free (ptr);
-     |      |   ~~~~~~~~~~~~~~~~~~~
-     |      |   |
-     |      |   (8) passing freed pointer 'ptr' in call to 'may_call_free' from 'test'
-     |
-     +--> 'may_call_free': events 9-12
-                 |
-                 |   NN | may_call_free (void *victim)
-                 |      | ^~~~~~~~~~~~~
-                 |      | |
-                 |      | (9) entry to 'may_call_free'
-                 |   NN | {
-                 |   NN |   if (some_condition ())
-                 |      |      ~
-                 |      |      |
-                 |      |      (10) following 'false' branch...
-                 |......
-                 |   NN |   free (victim);
-                 |      |   ~~~~~~~~~~~~~
-                 |      |   |
-                 |      |   (11) ...to here
-                 |      |   (12) second 'free' here; first 'free' was at (6)
-                 |
+    |
+    |   NN |   may_call_free (ptr);
+    |      |   ^~~~~~~~~~~~~~~~~~~
+    |      |   |
+    |      |   (7) returning to 'test' from 'may_call_free'
+    |......
+    |   NN |   may_call_free (ptr);
+    |      |   ~~~~~~~~~~~~~~~~~~~
+    |      |   |
+    |      |   (8) passing freed pointer 'ptr' in call to 'may_call_free' from 'test'
+    |
+    +--> 'may_call_free': events 9-12
+           |
+           |   NN | may_call_free (void *victim)
+           |      | ^~~~~~~~~~~~~
+           |      | |
+           |      | (9) entry to 'may_call_free'
+           |   NN | {
+           |   NN |   if (some_condition ())
+           |      |      ~
+           |      |      |
+           |      |      (10) following 'false' branch...
+           |......
+           |   NN |   free (victim);
+           |      |   ~~~~~~~~~~~~~
+           |      |   |
+           |      |   (11) ...to here
+           |      |   (12) second 'free' here; first 'free' was at (6)
+           |
   { dg-end-multiline-output "" } */
diff --git a/gcc/testsuite/gcc.dg/analyzer/malloc-ipa-8-double-free.c b/gcc/testsuite/gcc.dg/analyzer/malloc-ipa-8-double-free.c
index 7bc46ce..a63e7e8 100644
--- a/gcc/testsuite/gcc.dg/analyzer/malloc-ipa-8-double-free.c
+++ b/gcc/testsuite/gcc.dg/analyzer/malloc-ipa-8-double-free.c
@@ -1,9 +1,6 @@
 /* Example of a multilevel wrapper around malloc/free, with a double-'free'.  */
 
-/* { dg-options "--analyzer -fdiagnostics-show-line-numbers -fdiagnostics-nn-line-numbers -fanalyzer-checker=malloc -fanalyzer-verbose-state-changes" } */
-
-/* FIXME: we shouldn't need this.  */
-/* { dg-additional-options "-fanalyzer-fine-grained" } */
+/* { dg-options "--analyzer -fdiagnostics-show-line-numbers -fdiagnostics-nn-line-numbers -fanalyzer-checker=malloc -fanalyzer-verbose-state-changes -fdiagnostics-show-caret" } */
 
 #include <stdlib.h>
 
@@ -49,124 +46,126 @@ void test (int i)
 
 /* double-'free'.  */
 /* { dg-begin-multiline-output "" }
+   NN |   free (ptr);
+      |   ^~~~~~~~~~
   'test': events 1-2
-     |
-     |   NN | void test (int i)
-     |      |      ^~~~
-     |      |      |
-     |      |      (1) entry to 'test'
-     |   NN | {
-     |   NN |   boxed_int *obj = make_boxed_int (i);
-     |      |                    ~~~~~~~~~~~~~~~~~~
-     |      |                    |
-     |      |                    (2) calling 'make_boxed_int' from 'test'
-     |
-     +--> 'make_boxed_int': events 3-6
-                  |
-                  |   NN | make_boxed_int (int i)
-                  |      | ^~~~~~~~~~~~~~
-                  |      | |
-                  |      | (3) entry to 'make_boxed_int'
-                  |......
-                  |   NN |   if (!result)
-                  |      |      ~
-                  |      |      |
-                  |      |      (4) following 'false' branch (when 'result' is non-NULL)...
-                  |   NN |     abort ();
-                  |   NN |   result->i = i;
-                  |      |   ~~~~~~~~~~~~~
-                  |      |             |
-                  |      |             (5) ...to here
-                  |   NN |   return result;
-                  |      |          ~~~~~~
-                  |      |          |
-                  |      |          (6) state of '<return-value>': 'start' -> 'nonnull' (origin: NULL)
-                  |
-     <------------+
-     |
+    |
+    |   NN | void test (int i)
+    |      |      ^~~~
+    |      |      |
+    |      |      (1) entry to 'test'
+    |   NN | {
+    |   NN |   boxed_int *obj = make_boxed_int (i);
+    |      |                    ~~~~~~~~~~~~~~~~~~
+    |      |                    |
+    |      |                    (2) calling 'make_boxed_int' from 'test'
+    |
+    +--> 'make_boxed_int': events 3-6
+           |
+           |   NN | make_boxed_int (int i)
+           |      | ^~~~~~~~~~~~~~
+           |      | |
+           |      | (3) entry to 'make_boxed_int'
+           |......
+           |   NN |   if (!result)
+           |      |      ~
+           |      |      |
+           |      |      (4) following 'false' branch (when 'result' is non-NULL)...
+           |   NN |     abort ();
+           |   NN |   result->i = i;
+           |      |   ~~~~~~~~~~~~~
+           |      |             |
+           |      |             (5) ...to here
+           |   NN |   return result;
+           |      |          ~~~~~~
+           |      |          |
+           |      |          (6) state of '<return-value>': 'start' -> 'nonnull' (origin: NULL)
+           |
+    <------+
+    |
   'test': events 7-8
-     |
-     |   NN |   boxed_int *obj = make_boxed_int (i);
-     |      |                    ^~~~~~~~~~~~~~~~~~
-     |      |                    |
-     |      |                    (7) returning to 'test' from 'make_boxed_int'
-     |   NN | 
-     |   NN |   free_boxed_int (obj);
-     |      |   ~~~~~~~~~~~~~~~~~~~~
-     |      |   |
-     |      |   (8) calling 'free_boxed_int' from 'test'
-     |
-     +--> 'free_boxed_int': events 9-10
+    |
+    |   NN |   boxed_int *obj = make_boxed_int (i);
+    |      |                    ^~~~~~~~~~~~~~~~~~
+    |      |                    |
+    |      |                    (7) returning to 'test' from 'make_boxed_int'
+    |   NN | 
+    |   NN |   free_boxed_int (obj);
+    |      |   ~~~~~~~~~~~~~~~~~~~~
+    |      |   |
+    |      |   (8) calling 'free_boxed_int' from 'test'
+    |
+    +--> 'free_boxed_int': events 9-10
+           |
+           |   NN | free_boxed_int (boxed_int *bi)
+           |      | ^~~~~~~~~~~~~~
+           |      | |
+           |      | (9) entry to 'free_boxed_int'
+           |   NN | {
+           |   NN |   wrapped_free (bi);
+           |      |   ~~~~~~~~~~~~~~~~~
+           |      |   |
+           |      |   (10) calling 'wrapped_free' from 'free_boxed_int'
+           |
+           +--> 'wrapped_free': events 11-12
                   |
-                  |   NN | free_boxed_int (boxed_int *bi)
-                  |      | ^~~~~~~~~~~~~~
-                  |      | |
-                  |      | (9) entry to 'free_boxed_int'
+                  |   NN | void wrapped_free (void *ptr)
+                  |      |      ^~~~~~~~~~~~
+                  |      |      |
+                  |      |      (11) entry to 'wrapped_free'
                   |   NN | {
-                  |   NN |   wrapped_free (bi);
-                  |      |   ~~~~~~~~~~~~~~~~~
+                  |   NN |   free (ptr);
+                  |      |   ~~~~~~~~~~
                   |      |   |
-                  |      |   (10) calling 'wrapped_free' from 'free_boxed_int'
+                  |      |   (12) first 'free' here (state of 'ptr': 'nonnull' -> 'freed', origin: NULL)
                   |
-                  +--> 'wrapped_free': events 11-12
-                              |
-                              |   NN | void wrapped_free (void *ptr)
-                              |      |      ^~~~~~~~~~~~
-                              |      |      |
-                              |      |      (11) entry to 'wrapped_free'
-                              |   NN | {
-                              |   NN |   free (ptr);
-                              |      |   ~~~~~~~~~~
-                              |      |   |
-                              |      |   (12) first 'free' here (state of 'ptr': 'nonnull' -> 'freed', origin: NULL)
-                              |
-                  <-----------+
-                  |
-          'free_boxed_int': event 13
-                  |
-                  |   NN |   wrapped_free (bi);
-                  |      |   ^~~~~~~~~~~~~~~~~
-                  |      |   |
-                  |      |   (13) returning to 'free_boxed_int' from 'wrapped_free'
-                  |
-     <------------+
-     |
+           <------+
+           |
+         'free_boxed_int': event 13
+           |
+           |   NN |   wrapped_free (bi);
+           |      |   ^~~~~~~~~~~~~~~~~
+           |      |   |
+           |      |   (13) returning to 'free_boxed_int' from 'wrapped_free'
+           |
+    <------+
+    |
   'test': events 14-15
-     |
-     |   NN |   free_boxed_int (obj);
-     |      |   ^~~~~~~~~~~~~~~~~~~~
-     |      |   |
-     |      |   (14) returning to 'test' from 'free_boxed_int'
-     |   NN | 
-     |   NN |   free_boxed_int (obj);
-     |      |   ~~~~~~~~~~~~~~~~~~~~
-     |      |   |
-     |      |   (15) passing freed pointer 'obj' in call to 'free_boxed_int' from 'test'
-     |
-     +--> 'free_boxed_int': events 16-17
+    |
+    |   NN |   free_boxed_int (obj);
+    |      |   ^~~~~~~~~~~~~~~~~~~~
+    |      |   |
+    |      |   (14) returning to 'test' from 'free_boxed_int'
+    |   NN | 
+    |   NN |   free_boxed_int (obj);
+    |      |   ~~~~~~~~~~~~~~~~~~~~
+    |      |   |
+    |      |   (15) passing freed pointer 'obj' in call to 'free_boxed_int' from 'test'
+    |
+    +--> 'free_boxed_int': events 16-17
+           |
+           |   NN | free_boxed_int (boxed_int *bi)
+           |      | ^~~~~~~~~~~~~~
+           |      | |
+           |      | (16) entry to 'free_boxed_int'
+           |   NN | {
+           |   NN |   wrapped_free (bi);
+           |      |   ~~~~~~~~~~~~~~~~~
+           |      |   |
+           |      |   (17) passing freed pointer 'bi' in call to 'wrapped_free' from 'free_boxed_int'
+           |
+           +--> 'wrapped_free': events 18-19
                   |
-                  |   NN | free_boxed_int (boxed_int *bi)
-                  |      | ^~~~~~~~~~~~~~
-                  |      | |
-                  |      | (16) entry to 'free_boxed_int'
+                  |   NN | void wrapped_free (void *ptr)
+                  |      |      ^~~~~~~~~~~~
+                  |      |      |
+                  |      |      (18) entry to 'wrapped_free'
                   |   NN | {
-                  |   NN |   wrapped_free (bi);
-                  |      |   ~~~~~~~~~~~~~~~~~
+                  |   NN |   free (ptr);
+                  |      |   ~~~~~~~~~~
                   |      |   |
-                  |      |   (17) passing freed pointer 'bi' in call to 'wrapped_free' from 'free_boxed_int'
+                  |      |   (19) second 'free' here; first 'free' was at (12) ('ptr' is in state 'freed')
                   |
-                  +--> 'wrapped_free': events 18-19
-                              |
-                              |   NN | void wrapped_free (void *ptr)
-                              |      |      ^~~~~~~~~~~~
-                              |      |      |
-                              |      |      (18) entry to 'wrapped_free'
-                              |   NN | {
-                              |   NN |   free (ptr);
-                              |      |   ~~~~~~~~~~
-                              |      |   |
-                              |      |   (19) second 'free' here; first 'free' was at (12) ('ptr' is in state 'freed')
-                              |
    { dg-end-multiline-output "" } */
 
 /* TODO: the event describing the allocation is uninteresting and probably
diff --git a/gcc/testsuite/gcc.dg/analyzer/malloc-ipa-8-unchecked.c b/gcc/testsuite/gcc.dg/analyzer/malloc-ipa-8-unchecked.c
index e981b9a..a3a3909 100644
--- a/gcc/testsuite/gcc.dg/analyzer/malloc-ipa-8-unchecked.c
+++ b/gcc/testsuite/gcc.dg/analyzer/malloc-ipa-8-unchecked.c
@@ -1,6 +1,6 @@
 /* Example of a multilevel wrapper around malloc, with an unchecked write.  */
 
-/* { dg-options "--analyzer -fdiagnostics-show-line-numbers -fdiagnostics-nn-line-numbers -fdiagnostics-path-format=inline-events -fanalyzer-checker=malloc -fanalyzer-verbose-state-changes" } */
+/* { dg-options "--analyzer -fdiagnostics-show-line-numbers -fdiagnostics-nn-line-numbers -fdiagnostics-path-format=inline-events -fanalyzer-checker=malloc -fdiagnostics-show-caret -fanalyzer-verbose-state-changes" } */
 
 #include <stdlib.h>
 
@@ -24,41 +24,43 @@ make_boxed_int (int i)
 
 /* "dereference of possibly-NULL 'result' [CWE-690]".  */
 /* { dg-begin-multiline-output "" }
+   NN |   result->i = i;
+      |   ~~~~~~~~~~^~~
   'make_boxed_int': events 1-2
-          |
-          |   NN | make_boxed_int (int i)
-          |      | ^~~~~~~~~~~~~~
-          |      | |
-          |      | (1) entry to 'make_boxed_int'
-          |   NN | {
-          |   NN |   boxed_int *result = (boxed_int *)wrapped_malloc (sizeof (boxed_int));
-          |      |                                    ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
-          |      |                                    |
-          |      |                                    (2) calling 'wrapped_malloc' from 'make_boxed_int'
-          |
-          +--> 'wrapped_malloc': events 3-4
-                       |
-                       |   NN | void *wrapped_malloc (size_t size)
-                       |      |       ^~~~~~~~~~~~~~
-                       |      |       |
-                       |      |       (3) entry to 'wrapped_malloc'
-                       |   NN | {
-                       |   NN |   return malloc (size);
-                       |      |          ~~~~~~~~~~~~~
-                       |      |          |
-                       |      |          (4) this call could return NULL (state of '<return-value>': 'start' -> 'unchecked', origin: NULL)
-                       |
-          <------------+
-          |
+    |
+    |   NN | make_boxed_int (int i)
+    |      | ^~~~~~~~~~~~~~
+    |      | |
+    |      | (1) entry to 'make_boxed_int'
+    |   NN | {
+    |   NN |   boxed_int *result = (boxed_int *)wrapped_malloc (sizeof (boxed_int));
+    |      |                                    ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+    |      |                                    |
+    |      |                                    (2) calling 'wrapped_malloc' from 'make_boxed_int'
+    |
+    +--> 'wrapped_malloc': events 3-4
+           |
+           |   NN | void *wrapped_malloc (size_t size)
+           |      |       ^~~~~~~~~~~~~~
+           |      |       |
+           |      |       (3) entry to 'wrapped_malloc'
+           |   NN | {
+           |   NN |   return malloc (size);
+           |      |          ~~~~~~~~~~~~~
+           |      |          |
+           |      |          (4) this call could return NULL (state of '<return-value>': 'start' -> 'unchecked', origin: NULL)
+           |
+    <------+
+    |
   'make_boxed_int': events 5-6
-          |
-          |   NN |   boxed_int *result = (boxed_int *)wrapped_malloc (sizeof (boxed_int));
-          |      |                                    ^~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
-          |      |                                    |
-          |      |                                    (5) possible return of NULL to 'make_boxed_int' from 'wrapped_malloc'
-          |   NN |   result->i = i;
-          |      |   ~~~~~~~~~~~~~                     
-          |      |             |
-          |      |             (6) 'result' could be NULL: unchecked value from (4) ('result' is in state 'unchecked')
-          |
+    |
+    |   NN |   boxed_int *result = (boxed_int *)wrapped_malloc (sizeof (boxed_int));
+    |      |                                    ^~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+    |      |                                    |
+    |      |                                    (5) possible return of NULL to 'make_boxed_int' from 'wrapped_malloc'
+    |   NN |   result->i = i;
+    |      |   ~~~~~~~~~~~~~                     
+    |      |             |
+    |      |             (6) 'result' could be NULL: unchecked value from (4) ('result' is in state 'unchecked')
+    |
   { dg-end-multiline-output "" } */
